﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using DotSpatial.Data;
using DotSpatial.Topology;
using System.Globalization;

namespace FeatureManager
{
    public class FeatureReader
    {
        FeatureSet features = new FeatureSet(); //Kolekce geoprvků (instancí třídy Feature)
        /*
         * Metoda vrací instanci třídy FeatureSet 
         * obsahující body v podobě instancí třídy Feature typu Point
         * načtené z CSV souboru.
         */
        public FeatureSet getFeatures(string filename)
        {
            string line;
            System.IO.StreamReader file = new System.IO.StreamReader(filename);
            while ((line = file.ReadLine()) != null)
            {
                /*
                 * Vhodné upravit pro obecný oddělovač. 
                 */
                string[] words = line.Split(';');
                Point f = new Point(Convert.ToDouble(words[0]), Convert.ToDouble(words[1])); //Vytvoření nového bodu instanec třídy DotSpatial.Topology.Point
                features.AddFeature(f);
            }

            file.Close();
            return features;
        }
    }

    public class FeatureWriter
    {
        /*
         * Ukazka vypisu souranic polygonu do csv
         */

        public static void saveFeatures(string filename, FeatureSet features)
        {
            System.IO.StreamWriter file = new System.IO.StreamWriter(filename);
            //Prochazi kolekci FeatureSet
            foreach (Feature f in features.Features)
            {
                //Pokud je geoprvek polygon
                if (f.ShapeType == ShapeType.Polygon) {
                    //Projde vsechny souradnice polygonu
                    foreach (Coordinate cor in f.Coordinates) {
                        //file.Write(cor.X + " " + cor.Y + ","); //Dle regional settings
                        //Bez pouziti regional settings
                        file.Write(cor.X.ToString(CultureInfo.InvariantCulture) + " " + cor.Y.ToString(CultureInfo.InvariantCulture) + ",");
                    }
                    file.WriteLine();
                }
                
            }
            
            file.Close();
            
        }
    }
}
