﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FeatureManager;
using DotSpatial.Data;
using DotSpatial.Symbology;
using DotSpatial.Topology;
using DotSpatial.Controls;
using DotSpatial.Projections;

namespace GeodataBrowser
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
            //Nastaveni EPSG 4326 pro celou mapu - neni nutne - 4326 je implicitni
            //Navic nestaci nastavit jen kod
            /*ProjectionInfo pinfo = new ProjectionInfo();
            pinfo.EpsgCode = 4326;
            map1.Projection = pinfo;
             * */
        }

        private void openDirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //naplneni listu soubory s danymi priponami
            string[] masks = { "*.shp", "*.csv" };
            fillListBox(masks);
        }

        private void fillListBox(String[] masks) {
            //System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(@"D:\ruz76\cr-shp-wgs84\plochy\");
            //Cesta k adresari - pro aplikaci nutno upravit na vyber uzivatelem
            System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(@"C:\temp\plochy");
            //Prochazi seznam masek - typu souboru
            for (int i = 0; i < masks.Length; i++) {
                //Prochazi seznam souboru daneho typu
                foreach (System.IO.FileInfo f in dir.GetFiles(masks[i]))
                {
                    //Nazev souboru vcetně cesty prida do seznamu
                    listBox1.Items.Add(f.FullName);
                }
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Odstrani predchozi vrstvu z nahledove mapy
            map1.Layers.Clear();
            //Precte nazev vybraneho souboru
            String name = listBox1.SelectedItem.ToString();
            //Pokud ma priponu shp
            if (name.Substring(name.Length - 3, 3) == "shp") {
                //Prida jej primo do mapy
                map1.AddLayer(listBox1.SelectedItem.ToString());
            }
            //Pokud ma priponu csv
            if (name.Substring(name.Length - 3, 3) == "csv")
            {
                //Preda jej tride FeatureReader
                FeatureReader fr = new FeatureReader();
                //Feature reader se pokusi z nej precist body a vratit FeatureSet
                FeatureSet fs = fr.getFeatures(name);
                //Vlozeni bodove vrstvy do mapy
                MapPointLayer layer = new MapPointLayer(fs);
                layer.Symbolizer = new  PointSymbolizer(Color.Blue, DotSpatial.Symbology.PointShape.Star, 15);
                //Nastaveni projekce pro vkladanou vrstvu na projekci mapy               
                layer.Projection = map1.Projection;
                map1.Layers.Add(layer);
            }
        }

        private void listBox1_DoubleClick(object sender, EventArgs e)
        {
            //Vyuziti FeatureWriter k zapsani souradnice existujici vrstvy do csv
            String name = listBox1.SelectedItem.ToString() + ".csv";
            FeatureSet fs = (FeatureSet) ((IFeatureLayer)map1.Layers[0]).DataSet;
            FeatureWriter.saveFeatures(name, fs);
        }
    }
}
